// complexOLS.cpp:      .
//

#include "stdafx.h"
#include "Complex.h"
#include "ComplexApprox.h"

/*void MatrixMult(COMPLEX Matrix[], COMPLEX Vec[], COMPLEX Result[], unsigned int Size)
{
	COMPLEX* Line = Matrix;

	for (unsigned int i = 0; i < Size; i++)
	{
		ComplexInit(&Result[i], 0, 0);
		for (unsigned int j = 0; j < Size; j++)
		{
			COMPLEX tmp;
			ComplexMul(&tmp, &Line[j], &Vec[j]);
			ComplexAdd(&Result[i], &Result[i], &tmp);
		}
		Line += Size;
	}
}*/

/*void LinesXchg(COMPLEX* Pointers[], COMPLEX b[], unsigned int Index1, unsigned int Index2)
{
	COMPLEX tmp;
	tmp = b[Index1];
	b[Index1] = b[Index2];
	b[Index2] = tmp;

	COMPLEX* tmpP = Pointers[Index1];
	Pointers[Index1] = Pointers[Index2];
	Pointers[Index2] = tmpP;
}*/

/*void CalcDet(COMPLEX* Pointers[], unsigned int Size, COMPLEX* Result)
{
	ComplexInit(Result, 0, 0);
	if (Size == 1)
	{
		*Result = Pointers[0][0];
		return;
	}

	COMPLEX** pPointers = (COMPLEX**)malloc((Size - 1) * sizeof(COMPLEX*));
	for (unsigned int i = 0; i < Size; i++)
	{
		for (unsigned int j = 0; j < i; j++)
		{
			pPointers[j] = Pointers[j] + 1;
		}
		for (unsigned int j = i + 1; j < Size; j++)
		{
			pPointers[j - 1] = Pointers[j] + 1;
		}
		COMPLEX tmp;
		CalcDet(pPointers, Size - 1, &tmp);
		//Pointers[i][0];
		ComplexMul(&tmp, &tmp, &Pointers[i][0]);
		if (i % 2 == 0)
		{
			tmp.NRe = -tmp.NRe;
			tmp.NIm = -tmp.NIm;
		}
		ComplexAdd(Result, Result, &tmp);
	}
	free(pPointers);
}*/
/*void SolveSystemKramer(COMPLEX* Pointers[], COMPLEX b[], COMPLEX Result[], unsigned int Size)
{
	COMPLEX* Col = (COMPLEX*)malloc(sizeof(COMPLEX)*Size);

	COMPLEX det;
	CalcDet(Pointers, Size, &det);

	for (unsigned int i = 0; i < Size; i++)
	{
		for (unsigned int j = 0; j < Size; j++)
		{
			Col[j] = Pointers[j][i];
			Pointers[j][i] = b[j];
		}
		COMPLEX deti;
		CalcDet(Pointers, Size, &deti);
		ComplexDiv(&Result[i], &deti, &det);
		for (unsigned int j = 0; j < Size; j++)
		{
			Pointers[j][i] = Col[j];
		}
	}

	free(Col);
}*/

/*void SolveSystemGauss(COMPLEX Matrix[], COMPLEX b[], COMPLEX Result[], unsigned int Size, COMPLEX* Pointers[])
{
	MatrixToPointers(Matrix, Size, Pointers);

	for (unsigned int i = 0; i < Size - 1; i++)
	{
		double Max = Pointers[i][i].A;
		unsigned int MaxIndex = i;

		for (unsigned int j = i + 1; j < Size; j++)
		{
			if (Pointers[j][i].A > Max)
			{
				Max = Pointers[j][i].A;
				MaxIndex = j;
			}
		}

		if (MaxIndex != i)
		{
			LinesXchg(Pointers, b, i, MaxIndex);
		}

		COMPLEX a = Pointers[i][i];
		for (unsigned int j = i + 1; j < Size; j++)
		{
			COMPLEX c;
			COMPLEX* CurLine = Pointers[j];
			ComplexDiv(&c, &CurLine[i], &a);

			//for (unsigned int k = i; k < Size; k++)
			for (unsigned int k = 0; k < Size; k++)
			{
				COMPLEX tmp;
				ComplexMul(&tmp, &c, &Pointers[i][k]);
				ComplexSub(&CurLine[k], &CurLine[k], &tmp);
			}
			COMPLEX tmp;
			ComplexMul(&tmp, &c, &b[i]);
			ComplexSub(&b[j], &b[j], &tmp);
		}
	}

	for (unsigned int i = Size; i > 0; i--)
	{
		unsigned int k = i - 1;

		COMPLEX Sum = b[k];

		for (unsigned int j = k + 1; j < Size; j++)
		{
			COMPLEX tmp;
			ComplexMul(&tmp, &Pointers[k][j], &Result[j]);
			ComplexSub(&Sum, &Sum, &tmp);
		}
		
		ComplexDiv(&Result[k], &Sum, &Pointers[k][k]);
	}
}*/

#define NumOfPoints 100
#define ResultLength 40

int main()
{
	LARGE_INTEGER q;
	QueryPerformanceCounter(&q);
	srand(q.HighPart^q.LowPart);

	POLY_POINT Points[NumOfPoints];
	/*ComplexInit(&Points[0].x, 1, 1);
	ComplexInit(&Points[0].y, 2, 0);

	ComplexInit(&Points[1].x, 3.5, -1);
	ComplexInit(&Points[1].y, -0.6, 0);

	ComplexInit(&Points[2].x, 0, 1.4);
	ComplexInit(&Points[2].y, -2, -1);*/
	for (unsigned int i = 0; i < NumOfPoints; i++)
	{
		double Delta = 1000;
		do
		{
			ComplexRandom(&Points[i].x, -3, 3, -3, 3);
			for (unsigned int j = 0; i < i; j++)
			{
				COMPLEX tmp;
				ComplexSub(&tmp, &Points[j].x, &Points[i].x);
				Delta = min(Delta, tmp.A);
			}
		} while (Delta <= DBL_EPSILON);
		Delta = 1000;
		do
		{
			ComplexRandom(&Points[i].y, -3, 3, -3, 3);
			for (unsigned int j = 0; i < i; j++)
			{
				COMPLEX tmp;
				ComplexSub(&tmp, &Points[j].y, &Points[i].y);
				Delta = min(Delta, tmp.A);
			}
		} while (Delta <= DBL_EPSILON);
	}

	COMPLEX Matrix[ResultLength*ResultLength];
	COMPLEX* Pointers[ResultLength];
	COMPLEX b[ResultLength];
	MatrixFromPoints(Points, NumOfPoints, Matrix, ResultLength, b);
	MatrixToPointers(Matrix, ResultLength, Pointers);

	COMPLEX Poly[ResultLength];
	COMPLEX Prev[ResultLength];
	Relax(Pointers, b, ResultLength, 1.0E-7, Poly, Prev);

	for (unsigned int i = 0; i < NumOfPoints; i++)
	{
		COMPLEX Val;
		CalcPoly(Poly, ResultLength, &Points[i].x, &Val);
		ComplexSub(&Val, &Val, &Points[i].y);
		printf("%u: %e\n", i, Val.A);
	}

	printf("DONE!\n");
	int govno;
	scanf_s("%d", &govno);
	return 0;
}

